/*
 * JSyntaxTextPane.java
 *
 * Created on 30 ottobre 2007, 21.53
 *
 */

package jsyntax;

import java.awt.Component;
import javax.swing.JTextPane;
import javax.swing.plaf.ComponentUI;

/**
 *
 * @author Dario Lucia
 */
public class JSyntaxTextPane extends JTextPane {
    
    private JSyntaxDocument document;
    
    /** Creates a new instance of JSyntaxTextPane */
    public JSyntaxTextPane(JSyntaxTokenDivisorManager divs, JSyntaxKeywordManager keys,boolean undoSupport) {
        super();
        this.document = new JSyntaxDocument(divs,keys,undoSupport);
        super.setDocument(this.document);
        this.document.registerTextPane(this);
    }
    
    // The method below is coutesy of Core Swing Advanced Programming by Kim Topley
    public boolean getScrollableTracksViewportWidth() {
        Component parent = getParent();
    	ComponentUI ui = getUI();

    	return parent != null ? (ui.getPreferredSize(this).width <= parent.getSize().width) : true;
    }
    
    public void undo() {
        this.document.undoAction();
    }
    
    public void redo() {
        this.document.redoAction();
    }
    
}
