/*
 * JSyntaxTestApp.java
 *
 * Created on 28 ottobre 2007, 18.41
 */

package jsyntax.sample;

import java.awt.Color;
import java.awt.Dimension;
import java.util.LinkedList;
import java.util.List;
import java.util.Vector;
import javax.swing.JScrollPane;
import jsyntax.*;

/**
 *
 * @author  Dario
 */
public class JSyntaxTestApp extends javax.swing.JFrame {
    
    private JSyntaxManager syntaxmanager;
    private JSyntaxTextPane jTextPane1;
    private JScrollPane jScrollPane1;
    
    /** Creates new form JSyntaxTestApp */
    public JSyntaxTestApp() {
        initComponents();
        
        List<String> keys = new LinkedList<String>();
        keys.add("def");
        keys.add("where");
        keys.add("end");
        keys.add("cuboid");
        keys.add("isreal");
        keys.add("isnat");
        keys.add("map");
        keys.add("AA");
        keys.add("align");
        keys.add("struct");
        keys.add("view");
        JSyntaxKeywordManager keywords = new JSyntaxKeywordManager();
        keywords.addFormat(keys,Color.BLUE,true,false,false);
        
        List<Character> divs = new LinkedList<Character>();
        divs.add(new Character(' '));
        divs.add(new Character('\n'));
        divs.add(new Character('\r'));
        divs.add(new Character('\t'));
        divs.add(new Character(':'));
        divs.add(new Character('='));
        divs.add(new Character(']'));
        divs.add(new Character('['));
        divs.add(new Character('('));
        divs.add(new Character(')'));
        divs.add(new Character('/'));
        divs.add(new Character('+'));
        divs.add(new Character('*'));
        divs.add(new Character('%'));
        divs.add(new Character('&'));
        divs.add(new Character('^'));
        divs.add(new Character('"'));
        divs.add(new Character('\''));
        divs.add(new Character('{'));
        divs.add(new Character('}'));
        divs.add(new Character('<'));
        divs.add(new Character('>'));
        divs.add(new Character(';'));
        divs.add(new Character(','));
        divs.add(new Character('-'));
        JSyntaxTokenDivisorManager divisors = new JSyntaxTokenDivisorManager(divs);
        
        this.syntaxmanager = new JSyntaxManager(divisors, keywords);
        this.jTextPane1 = this.syntaxmanager.getJSyntaxTextPane(true);
        this.jScrollPane1 = new JScrollPane(this.jTextPane1);
        this.getContentPane().add(jScrollPane1,java.awt.BorderLayout.CENTER);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jPanel1 = new javax.swing.JPanel();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setMinimumSize(new java.awt.Dimension(400, 350));
        jPanel1.setLayout(new java.awt.BorderLayout());

        jButton1.setText("Undo");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jPanel1.add(jButton1, java.awt.BorderLayout.WEST);

        jButton2.setText("Redo");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jPanel1.add(jButton2, java.awt.BorderLayout.EAST);

        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setText("JSyntax Test Application");
        jLabel1.setToolTipText("JSyntax Test Application");
        jPanel1.add(jLabel1, java.awt.BorderLayout.CENTER);

        getContentPane().add(jPanel1, java.awt.BorderLayout.SOUTH);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        JSyntaxDocument doc = (JSyntaxDocument) this.jTextPane1.getDocument();
        doc.redoAction();
        this.jTextPane1.requestFocus();
    }//GEN-LAST:event_jButton2ActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        JSyntaxDocument doc = (JSyntaxDocument) this.jTextPane1.getDocument();
        doc.undoAction();
        this.jTextPane1.requestFocus();
    }//GEN-LAST:event_jButton1ActionPerformed
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new JSyntaxTestApp().setVisible(true);
            }
        });
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    // End of variables declaration//GEN-END:variables

    
    
}
