/*
 * JSyntaxRemoveTextAction.java
 *
 * Created on 30 ottobre 2007, 19.57
 *
 */

package jsyntax.undo;

import javax.swing.text.AttributeSet;
import javax.swing.text.BadLocationException;
import javax.swing.text.SimpleAttributeSet;
import jsyntax.JSyntaxDocument;

/**
 *
 * @author dario
 */
public class JSyntaxRemoveTextAction implements UndoableAction {
    
    private static final AttributeSet ATTRIBUTE_SET = new SimpleAttributeSet();
    
    private String text;
    private int index;
    
    /** Creates a new instance of JSyntaxRemoveTextAction */
    public JSyntaxRemoveTextAction( String text , int index) {
        this.text = text;
        this.index = index;
    }
    
    
    public void undoOperation(JSyntaxDocument doc) {
        try {
            doc.insertStringFromUndo(index,text,ATTRIBUTE_SET);
        } catch (BadLocationException e) {
            e.printStackTrace();
        }
    }

    public void redoOperation(JSyntaxDocument doc) {
        try {
            doc.removeFromUndo(index,text.length());
        } catch (BadLocationException e) {
            e.printStackTrace();
        }
    }
}
